# Blue Coconut version 1.0, Copyright 2004 Paul Mison.

use strict;
use warnings;

package Blue_Coconut::Rendezvous;

use Encode;
use Net::Rendezvous;

sub new {
  my $proto = shift;
  my $class = ref($proto) || $proto;

  my $self = {};
  bless ($self, $class);

  return $self;
}

sub get_shares {
  my $self = shift;

  {
    # Work around bug in Net::DNS::Packet's dn_expand_XS
    no warnings 'redefine';
    *Net::DNS::Packet::dn_expand = \&Net::DNS::Packet::dn_expand_PP;
  }

  my $shares;
  
  my $res = Net::Rendezvous->new('daap');
  $res->discover;

  foreach my $entry ($res->entries) {
    my $name = $entry->name;
    $name = Encode::decode('utf-8', $name);

    $shares->{$name} = { name     => $name,
                         hostname => $entry->hostname,
                         address  => $entry->address,
                         port     => $entry->port,
                       };
  }

  return $shares;
}

1;
